cryptol-2.4.0: Cryptol: The Language of Cryptography

Copyright | (c) 2015-2016 Galois Inc.
License | BSD3
Maintainer | cryptol@galois.com
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Cryptol.TypeCheck.Solver.Simplify

Description

Synopsis

- tryRewritePropAsSubst :: Map TVar Interval -> Prop -> Maybe (TVar, Type)

# Documentation

tryRewritePropAsSubst :: Map TVar Interval -> Prop -> Maybe (TVar, Type) Source #

When given an equality constraint, attempt to rewrite it to the form `?x = ...`, by moving all occurrences of `?x` to the LHS, and any other variables to the RHS. This will only work when there's only one unification variable present in the prop.